import os
import sys
import pathlib
import random
import string
import shutil

random_str = lambda e:"".join(random.choices(string.ascii_letters, k=e))

def generate_random_arbre(path, depth, arity, contents):
    c = 0
    print(path, depth)
    if depth == 0:
        return 0
    for _ in range(random.randint(5*arity, 10*arity)):
        with open(pathlib.Path(path, random_str(5)), "w") as f:
            f.write(random.choice(contents))
        c += 1
    
    for _ in range(random.randint(0, arity)):
        p = pathlib.Path(path, random_str(5))
        p.mkdir()
        c += generate_random_arbre(p, depth-1, arity, contents)
    return c


if __name__ == "__main__":
    if len(sys.argv) == 1:
        raise ValueError("""
Utilisez le script de la manière suivante:

python3 genere_arbre.py chemin/ou/mettre/le/repertoire

Par exemple:

python3 genere_arbre.py arbo
""")
    path = pathlib.Path(sys.argv[1])
    if not path.exists():
        path.mkdir(parents=True)
    contents = ["Chouquette",
        "Poulet roti",
        "Banane",
        "Bonbon",
        "Éclaire aux Chocolat",
        "Couscous",
        "Tarte à la crème",
        "Merveilleux",
        "Millefeuilles",
        "Religieuse au café",
        "Maïs",
        "Houmous",
        "Camembert",
        "Boeuf bourguignon",
        "Cassoulet",
        "Canard laqué"
    ]
    while generate_random_arbre(path, depth=6, arity=5, contents=contents) < 1000:
        shutil.rmtree(path)
        path.mkdir()
        
    
    

